import java.io.*;
import java.text.NumberFormat;

public class Test {

    public Test() {
    }

    public void numberFormat() {
        double d = 345.36245687;
        System.out.println("d, unformatted: " + d);
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        System.out.println("d, formatted: " + nf.format(d));
        System.out.println();
    }
    
    public void math() {
        double d = 345.36245687;
        System.out.println("sin(d): " + Math.sin(d));
        System.out.println("cos(d): " + Math.cos(d));
        System.out.println();
    }
    
    public void showStrangeThing(String s1, ContextLabel cl, String s2) {
        System.out.println("This is the string passed: " + s1);
        cl.showContext(s2);
    }

    public Dancer returnDancer() {
//        Dancer d = new Dancer();
//        return new Dancer("Konstantin", "Kostjukov", 180.0, 70.0F, 37, false, 'A');
        BalletDancer bd = new BalletDancer("Narodno pozoriste");
        return bd;
//        return new Object();
    }

    public void demonstrateShowClass() {
        Dance foxtrot = new Dance(); 
        foxtrot.showClass(foxtrot);
    }

    public void demonstrateIllegalIndex() {
        int[] aa = new int[] {3, 4, 5};
        try {
            for (int i = 0; i <= (aa.length - 1); i++) {
                aa[i] = i + 15;
                System.out.println("aa[" + i + "] = " + aa[i]);
            }
        } catch (ArrayIndexOutOfBoundsException e) {
            System.err.println("Caught ArrayIndexOutOfBoundsException, yeah!");
        } finally {
            System.out.println("Finally...");
        }
    }

    public void noAgeDancer() throws NoAgeDancerException {
        Dancer d = new Dancer();
//        try {
//            if (d.getAge() != 0) {
//                System.out.println("The dancer's age is: " + d.getAge());
//            }
//            else {
//                throw new NoAgeDancerException();
//            }
//        } catch (NoAgeDancerException e) {
//            System.err.println(e.getMessage() + ", No age");
//        }
            if (d.getAge() != 0) {
                System.out.println("The dancer's age is: " + d.getAge());
            }
            else {
                throw new NoAgeDancerException();
            }
    }

    public void saveDancerToFile() {
        File f = new File("dancer.txt");
        Dancer dancer = new Dancer("Fred", "Astaire", 175.0D, 57.5F, 58, true, 'B');
        try {
            PrintStream w = new PrintStream(f);
            w.println(dancer.getFirstName());
            w.println(dancer.getLastName());
            w.println(dancer.getHeight());
        } catch (FileNotFoundException e) {
        }
    }

    public Dancer readDancerFromFile() {
        File f = new File("dancer.txt");
        Dancer d = new Dancer();
        try {
            BufferedReader r = new BufferedReader(new FileReader(f));
            d.setFirstName(r.readLine());
            d.setLastName(r.readLine());
            d.setHeight(Double.parseDouble(r.readLine()));
            r.close();
        } catch (FileNotFoundException e) {
        } catch (IOException e) {
        }
        return d;
    }

    public double demonstrateKeyboardInput() {
        double d = -1.0;
        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
        try {
            System.out.println("Read a double: ");
            d = Double.parseDouble(r.readLine());
            r.close();
        } catch (IOException e) {
        }
        return d;
    }

    public void serializeDancerToFile(Dancer d) {
        File f = new File("serialized dancer.txt");
        try {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(f));
            out.writeObject(d);
            out.close();
        } catch (IOException e) {
        }
    }

    public Dancer deserializeDancerFromFile() {
        File f = new File("serialized dancer.txt");
        Dancer d = new Dancer();
        try {
            ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
            d = (Dancer)in.readObject();
            in.close();
            return d;
        } catch (IOException e) {
        } catch (ClassNotFoundException e) {
        }
        return d;
    }

}
